{% use 'form_div_layout.html.twig' %}

{%- block checkbox_widget -%}
  {%- if not (unstyled ?? false) %}
    {%- from '_macros/form.html.twig' import checkbox -%}
    {{- checkbox(attr|merge({
      id: id,
      name: full_name,
      value: value ?? false,
      disabled: disabled,
      required: required,
      checked: checked,
    })) -}}
  {%- else -%}
    {{- parent() -}}
  {%- endif -%}
{%- endblock checkbox_widget %}

{%- block radio_widget -%}
  {%- if not (unstyled ?? false) %}
    {%- from '_macros/form.html.twig' import radio -%}
    {{- radio(attr|merge({
      id: id,
      name: full_name,
      value: value ?? false,
      disabled: disabled,
      required: required,
      checked: checked,
    })) -}}
  {%- else -%}
    {{- parent() -}}
  {%- endif -%}
{%- endblock radio_widget %}

{# apply proper class to widgets  #}
{% block form_widget_simple %}
  {%- set attr = attr|merge({class: ((attr.class ?? '')~' form-control')|trim}) -%}
  {{- parent() -}}
{% endblock form_widget_simple %}

{%- block honeypot_row -%}
  <div hidden>
    {{- form_widget(form) -}}
  </div>
{%- endblock honeypot_row -%}

{% block textarea_widget %}
  {%- set attr = attr|merge({class: ((attr.class ?? '')~' form-control')|trim}) -%}
  {{- parent() -}}
{% endblock textarea_widget %}

{% block choice_widget %}
  {%- if not multiple and not expanded -%}
    <span class="unstylable-widget">
      {%- set attr = attr|merge({class: ((attr.class ?? '')~' form-control')|trim}) -%}
      {{- parent() -}}
      <span class="unstylable-widget__caret" aria-hidden="true"></span>
    </span>
  {%- else -%}
    {{- parent() -}}
  {%- endif -%}
{% endblock choice_widget %}

{# form layout #}

{%- block form_start -%}
  {%- set attr = attr|merge({'class': (attr.class is defined and attr.class|length > 0) ? attr.class~' form' : 'form'}) -%}
  {{- parent() -}}
{%- endblock form_start -%}

{%- block button_row -%}
  <div class="form__row form__button-row">
    {{- form_widget(form) -}}
  </div>
{%- endblock button_row -%}

{% block checkbox_row %}
  {{- form_errors(form) -}}
  <span class="form-row form-row--single-line form-row--no-collapse">
    {{- form_widget(form) -}}
    {{- form_label(form) -}}
  </span>
  {{- form_help(form) -}}
{% endblock checkbox_row %}

{% block form_help -%}
  {%- if help is not empty -%}
    {%- set help_attr = help_attr|merge({class: (help_attr.class|default('') ~ ' form-help text-sm fg-muted')|trim}) -%}
    {%- if not (raw_help ?? false) -%}
      <p id="{{ id }}_help"{% with { attr: help_attr } %}{{ block('attributes') }}{% endwith %}>
        {%- if translation_domain is same as(false) -%}
          {{- help -}}
        {%- else -%}
          {{- help|trans({}, translation_domain) -}}
        {%- endif -%}
      </p>
    {%- else -%}
      <div id="{{ id }}_help"{% with { attr: help_attr } %}{{ block('attributes') }}{% endwith %}>
        {{- help|raw -}}
      </div>
    {%- endif -%}
  {%- endif -%}
{%- endblock form_help %}

{%- block form_row -%}
  {%- if help is not empty -%}
    {%- set widget_attr = (widget_attr ?? {})|merge({ attr: { 'aria-describedby': id~"_help" } }) -%}
  {%- endif -%}
  {{- form_errors(form) -}}
  <div {% with { attr: (row_attr ?? {})|merge({ class: (row_attr.class ?? '')~' form-row form__row' }) } %}{{ block('attributes') }}{% endwith %}>
    {{- form_label(form, null, label_attr ?? {}) -}}
    {{- form_widget(form, attr|merge(widget_attr ?? {})) -}}
  </div>
  {{- form_help(form) -}}
{%- endblock form_row -%}

{%- block form_errors -%}
  {%- if errors|length > 0 -%}
    <ul class="form-error-list no-margin">
      {%- for error in errors -%}
        <li>{{ error.message }}</li>
      {%- endfor -%}
    </ul>
  {%- endif -%}
{%- endblock form_errors -%}

{# labels #}

{% block choice_label %}
  {#- hide required indicator when one element is always selected -#}
  {%- set show_required_indicator = show_required_indicator ?? (required and placeholder is not empty) -%}

  {{- block('form_label') -}}
{% endblock choice_label %}

{% block form_label %}
  {%- set show_required_indicator = show_required_indicator ?? required -%}
  {% if label is not same as(false) -%}
    {% if not compound -%}
      {% set label_attr = label_attr|merge({'for': id}) %}
    {%- endif -%}

    {% if label is empty -%}
      {%- if label_format is not empty -%}
        {% set label = label_format|replace({
          '%name%': name,
          '%id%': id,
        }) %}
      {%- else -%}
        {% set label = name|humanize %}
      {%- endif -%}
    {%- endif -%}

    <{{ element|default('label') }}{% if label_attr %}{% with { attr: label_attr } %}{{ block('attributes') }}{% endwith %}{% endif %}>
    {%- if translation_domain is same as(false) -%}
      {{- label -}}
    {%- else -%}
      {{- label|trans({}, translation_domain) -}}
    {%- endif %}
    {% if show_required_indicator -%}
      <b class="fg-red" role="presentation" title="{{ 'help.required_field'|trans }}" aria-label="{{ 'help.required_field'|trans }}">*</b>
    {%- endif -%}
    </{{ element|default('label') }}>
  {%- endif -%}
{% endblock form_label %}

{# misc widget stuff #}

{%- block button_widget -%}
  {%- set attr = attr|merge({'class': (attr.class ?? '')~' button'}) -%}
  {{- parent() -}}
{%- endblock button_widget -%}

{%- block captcha_widget -%}
  {%- apply spaceless -%}
    <div>
      {%- if not reload -%}
        <img src="{{ captcha_code }}" alt="" title="captcha" width="{{ captcha_width }}" height="{{ captcha_height }}">
      {%- else -%}
        <a class="captcha_reload" href="#" id="reload_{{ image_id }}">
          <img src="{{ captcha_code }}" alt="" title="{{ 'Renew'|trans({}, 'gregwar_captcha') }}" width="{{ captcha_width }}" height="{{ captcha_height }}">
        </a>
        {% cspscript %}
          <script>
            (function (linkId) {
              document.getElementById(linkId).addEventListener('click', function () {
                var img = this.getElementsByTagName('img')[0];
                img.src = '{{ captcha_code|e('js') }}?n=' + (new Date()).getTime();
              });
            })('reload_{{ image_id|e('js') }}');
          </script>
        {% endcspscript %}
      {%- endif -%}
    </div>
    {{- form_widget(form) -}}
  {%- endapply -%}
{%- endblock captcha_widget -%}

{% block datetime_widget %}
  {%- if widget == 'single_text' -%}
    {{ block('form_widget_simple') }}
  {%- else -%}
    <span class="compound-form-widget">
      {{- form_widget(form.date) -}}
      {{- form_widget(form.time) -}}
    </span>
  {%- endif -%}
{% endblock datetime_widget %}

{# remove surrounding <div> that breaks flexbox #}
{% block form_widget_compound %}
  {%- if form is rootform -%}
    {{- form_errors(form) -}}
  {%- endif -%}
  {{- block('form_rows') -}}
  {{- form_rest(form) -}}
{% endblock form_widget_compound %}

{# repeated form type #}

{% block repeated_errors %}
  {{- form_errors(form.first) -}}
{% endblock repeated_errors %}

{% block repeated_label %}
  {{- form_label(form.first) -}}
{% endblock repeated_label %}

{% block repeated_row %}
  {{- block('form_row') -}}
{% endblock repeated_row %}

{%- block repeated_widget -%}
  <div class="compound-form-widget">
    {{- form_widget(form.first, { attr: attr|merge(form.first.vars.attr) }) -}}
    {{- form_widget(form.second, { attr: attr|merge(form.second.vars.attr)|merge({
      'placeholder': 'placeholder.repeat',
      'aria-label': form.second.vars.label is defined
        ? form.second.vars.label|trans
        : (form.second.vars.label_format is defined
          ? form.second.vars.label_format|replace({'%name%': name, '%id%': id})
          : form.second.vars.name|humanize)
    })}) -}}
  </div>
{%- endblock repeated_widget -%}
